<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSolarSystemInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfSolarSystemInfo extends AbstractStructArrayBase
{
    /**
     * The SolarSystemInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\SolarSystemInfo[]
     */
    public $SolarSystemInfo;
    /**
     * Constructor method for ArrayOfSolarSystemInfo
     * @uses ArrayOfSolarSystemInfo::setSolarSystemInfo()
     * @param \CustomerManagement\StructType\SolarSystemInfo[] $solarSystemInfo
     */
    public function __construct(array $solarSystemInfo = array())
    {
        $this
            ->setSolarSystemInfo($solarSystemInfo);
    }
    /**
     * Get SolarSystemInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\SolarSystemInfo[]|null
     */
    public function getSolarSystemInfo()
    {
        return isset($this->SolarSystemInfo) ? $this->SolarSystemInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSolarSystemInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSolarSystemInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSolarSystemInfoForArrayConstraintsFromSetSolarSystemInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSolarSystemInfoSolarSystemInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfSolarSystemInfoSolarSystemInfoItem instanceof \CustomerManagement\StructType\SolarSystemInfo) {
                $invalidValues[] = is_object($arrayOfSolarSystemInfoSolarSystemInfoItem) ? get_class($arrayOfSolarSystemInfoSolarSystemInfoItem) : sprintf('%s(%s)', gettype($arrayOfSolarSystemInfoSolarSystemInfoItem), var_export($arrayOfSolarSystemInfoSolarSystemInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SolarSystemInfo property can only contain items of type \CustomerManagement\StructType\SolarSystemInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SolarSystemInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\SolarSystemInfo[] $solarSystemInfo
     * @return \CustomerManagement\ArrayType\ArrayOfSolarSystemInfo
     */
    public function setSolarSystemInfo(array $solarSystemInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($solarSystemInfoArrayErrorMessage = self::validateSolarSystemInfoForArrayConstraintsFromSetSolarSystemInfo($solarSystemInfo))) {
            throw new \InvalidArgumentException($solarSystemInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($solarSystemInfo) || (is_array($solarSystemInfo) && empty($solarSystemInfo))) {
            unset($this->SolarSystemInfo);
        } else {
            $this->SolarSystemInfo = $solarSystemInfo;
        }
        return $this;
    }
    /**
     * Add item to SolarSystemInfo value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\SolarSystemInfo $item
     * @return \CustomerManagement\ArrayType\ArrayOfSolarSystemInfo
     */
    public function addToSolarSystemInfo(\CustomerManagement\StructType\SolarSystemInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\SolarSystemInfo) {
            throw new \InvalidArgumentException(sprintf('The SolarSystemInfo property can only contain items of type \CustomerManagement\StructType\SolarSystemInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SolarSystemInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\SolarSystemInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\SolarSystemInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\SolarSystemInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\SolarSystemInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\SolarSystemInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SolarSystemInfo
     */
    public function getAttributeName()
    {
        return 'SolarSystemInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfSolarSystemInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
